#Region "file using directives"

Imports Microsoft.VisualBasic
Imports System
Imports System.Collections
Imports System.ComponentModel
Imports System.Drawing
Imports System.Data
Imports System.Windows.Forms
Imports System.Diagnostics
Imports System.Text

Imports Syncfusion.XlsIO
Imports Syncfusion.XlsIO.Implementation
Imports Syncfusion.Windows.Forms.Grid
Imports Syncfusion.Windows.Forms.Tools
Imports Syncfusion.Drawing
Imports Syncfusion.GridExcelConverter
#End Region

Namespace GridDataBoundGrid
	''' <summary>
	''' Summary description for MyGridExcelConverterControl.
	''' </summary>
	Public Class MyGridExcelConverterControl : Inherits GridExcelConverterControl
		Public Sub New()
			'
			' TODO: Add constructor logic here
			'
		End Sub

		Public Function ExcelToDataBoundGrid(ByVal strFileName As String, ByVal grid As GridModel) As DataTable
			If strFileName Is Nothing Then
				Throw New ArgumentNullException("strFileName")
			End If

			If strFileName.Length = 0 Then
				Throw New ArgumentException("strFileName - string can not be empty")
			End If

			If grid Is Nothing Then
				Throw New ArgumentNullException("grid")
			End If

			Dim dt As DataTable
			Dim engine As ExcelEngine = CreateEngine()
			Dim book As IWorkbook = engine.Excel.Workbooks.Open(strFileName)
			Dim sheet As IWorksheet = book.Worksheets(0)
			dt = ExcelToDataBoundGrid(sheet, grid)

			book.Close(False)
			Return dt
		End Function

		Public Function ExcelToDataBoundGrid(ByVal sheet As IWorksheet, ByVal grid As GridModel) As DataTable
			If sheet Is Nothing Then
				Throw New ArgumentNullException("sheet")
			End If

			If grid Is Nothing Then
				Throw New ArgumentNullException("grid")
			End If

			Dim dt As DataTable = New DataTable()
			Dim range As IRange = sheet.UsedRange
			Dim iFirstRow As Integer = range.Row
			Dim iLastRow As Integer = range.End.Row
			Dim iFirstCol As Integer = range.Column
			Dim iLastCol As Integer = range.End.Column

			grid.RowCount = iLastRow + 1
			grid.ColCount = iLastCol + 1

			Dim iCol As Integer = iFirstCol
'ORIGINAL LINE: for(int iCol = iFirstCol; iCol <= iLastCol; iCol += 1)
'INSTANT VB NOTE: This 'for' loop was translated to a VB 'Do While' loop:
			Do While iCol <= iLastCol
				Dim rangeToConvert As IRange = sheet.Range(iFirstRow, iCol)
				dt.Columns.Add(New DataColumn(rangeToConvert.Text))
				iCol += 1
			Loop
			Dim iRow As Integer = iFirstRow+1
'ORIGINAL LINE: for(int iRow = iFirstRow+1; iRow <= iLastRow; iRow += 1)
'INSTANT VB NOTE: This 'for' loop was translated to a VB 'Do While' loop:
			Do While iRow <= iLastRow
				Dim arr As Object() = New Object(iLastCol - 1) {}
				iCol = iFirstCol
'ORIGINAL LINE: for(int iCol = iFirstCol; iCol <= iLastCol; iCol += 1)
'INSTANT VB NOTE: This 'for' loop was translated to a VB 'Do While' loop:
				Do While iCol <= iLastCol
					Dim rangeToConvert As IRange = sheet.Range(iRow, iCol)
					arr(iCol-1) = rangeToConvert.Text
					iCol += 1
				Loop
				dt.Rows.Add(arr)
				iRow += 1
			Loop
			Return dt
		End Function
	End Class
End Namespace
